// contact me if you need help
var autosizerProgressListener = {
	QueryInterface: function(aIID) {
		if (aIID.equals(Ci.nsIWebProgressListener) || aIID.equals(Ci.nsISupportsWeakReference) || aIID.equals(Ci.nsISupports))
		  return this;
		throw Components.results.NS_NOINTERFACE;
	},
	onProgressChange: function (aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {},
	onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) {},
	onSecurityChange: function(aWebProgress, aRequest, aState) {},
	onLinkIconAvailable: function(a) {},
	onStateChange: function (aWebProgress, aRequest, aStateFlags, aStatus) {},
	onLocationChange: function(aProgress, aRequest, aLocation) { if (aLocation) autosizer.genWidthCheck(false); }
}

function AutosizerPrefObserver() {
	autosizer.checkPrefs(false);
}

AutosizerPrefObserver.prototype = {
  observe: function(subject, topic, pref) {
		try { if (topic == 'nsPref:changed') autosizer.checkPrefs(false); } catch(e) {}
	}
};

var autosizer = {
	init: function() {  
		window.removeEventListener("load",function() { autosizer.init(); }, false);
		this.prefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch).getBranch('browser.search.');	
    
    this.flexTemp=null;
    this.txtOld=this.byId("searchbar");
		this.initVar(); 
    
		if (this.prefs instanceof Ci.nsIPrefBranchInternal) {
			this.prefObserver = new AutosizerPrefObserver();
			this.prefs.addObserver('', this.prefObserver, false);
		}	  	
		
		var styleL=['font-Size','font-Size-Adjust','font-Stretch','font-Style','font-Variant','font-Weight','letter-Spacing','word-Spacing'];
		for(a in styleL) eval("this.label.style."+styleL[a].replace(/-/g, "")+"=document.defaultView.getComputedStyle(this.input, '').getPropertyValue('"+styleL[a]+"'); ");		
		
		addEventListener("load",function() { autosizer.genWidthCheck(false); }, false);
		addEventListener("resize",function() { autosizer.genWidth(false); }, false);
		getBrowser().addProgressListener(autosizerProgressListener, Ci.nsIWebProgress.STATE_STOP);
		
		// Inject code instead of XBL binding 
		if(this.txt && "handleSearchCommand" in this.txt)
      eval("this.txt.handleSearchCommand ="+this.txt.handleSearchCommand.toString().replace(
      'textBox.value;',
      'textBox.value; window.setTimeout("autosizer.afterSubmit();",0); '
      )); 	
		
		setTimeout("autosizer.startup();",0);
	}, 
	
	startup: function() {	
		this.getTooltipWidth(true);
		this.getNeededWidth(false);		    
		this.genWidth(false); // Force once
	},
	
	initVar: function() { 
		this.txt=this.byId("searchbar");
		this.sBox = this.byId("search-container");
		this.label=this.byId('autosizer-label'); 		
		var tb=this.txt._textbox;
   
		// Only needed when interface is rebuilt
		if(tb.hasAttribute('sizetopopup')) {   
      tb.setAttribute("onblur","autosizer.genWidthCheck();");
			tb.removeAttribute('sizetopopup'); // Removing this allows the popup to be sized in width. 
			var puMinWidth=this.prefs.getIntPref('autocompletePopupMinWidth');
			if(tb && "openPopup" in tb)
				eval("tb.openPopup ="+tb.openPopup.toString().replace(
					'this.boxObject.width',
					'(this.boxObject.width<'+puMinWidth+'?'+puMinWidth+':this.boxObject.width)'
					));         
			this.getNeededWidth();		
		}
		
		this.input=document.getAnonymousElementByAttribute(tb, "anonid", "input"); 	
		this.diffWidth=(1+this.sBox.boxObject.width)-this.input.offsetWidth;  		  
		this.sBox.flex=0;   
  },
	
	checkPrefs: function() {   
    this.offset=this.prefs.getIntPref('offset');
		this.labelOffset=this.prefs.getIntPref('labelOffset');
	  this.minwidth=this.prefs.getIntPref('minwidth');
		this.maxwidth=this.prefs.getIntPref('maxwidth');
		this.cleanOnSubmit=this.prefs.getBoolPref('cleanOnSubmit');
		this.revertOnSubmit=this.prefs.getBoolPref('revertOnSubmit');
		
		setTimeout("autosizer.getTooltipWidth(false);autosizer.genWidth(false);",0);
	},
	
	getNeededWidth: function() { 
		var toolbaritems=this.sBox.parentNode.childNodes,flextemp,i,x;
		this.neededWidth=0;
		for(i=0;x=toolbaritems[i];i++) {
			if(x.id=='search-container' || x.tagName=='toolbarspring') continue;
			flextemp=x.getAttribute('flex');
			x.setAttribute('flex',0);
			this.neededWidth+=x.boxObject.width+1;
			x.setAttribute('flex',flextemp);
		}
    this.neededWidth++;
	}, 		

	genWidth: function(evt) {
	  if(evt && evt.keyCode!=40 && evt.keyCode!=33 && evt.keyCode!=38 && evt.keyCode!=34 && this.txt.value.length>this.label.value.length+1) window.setTimeout("autosizer.focusEnd();",0); // on insertion fix - avoid if items were inserted by autocomplete	 			
    
    var availableWidth=window.outerWidth-this.neededWidth;     
    if(this.txt.getAttribute('empty')=='true') 
      this.label.value=''; // Avoid autosizing to search engine description if minwidth!=0
    else
    	this.label.value=this.txt.value;     
	  var width=this.label.boxObject.width+this.diffWidth+this.offset+9; // +9 explaination: If you type something in the searchbox, it is too narrow and moves the query to the left to display the just typed in letter. Once this is done, autosizer resizes the searchbar to its needed width. However, the text does not realign automatically. Therefore Autosizer would have to do so (like it does for the on insertion fix) but this procedure is quite slow which makes the typing look laggy. To prevent this, I just add 9 pixels to give enough space for the next letter. When done so, the searchbar is wide enough and it doesn't move the text
		if(width>this.maxwidth && this.maxwidth>0) width=this.maxwidth; // set max width 
		if(width<this.minwidth && this.minwidth>0) width=this.minwidth; // set min width
		if((this.txt.getAttribute('empty')=='true' || this.txt.value.length==0 || width<this.tooltipwidth) && this.tooltipwidth>0 && this.minwidth==0)
		  width=this.tooltipwidth+this.labelOffset; // set tooltip width (grey text)
		if(width>availableWidth && availableWidth>0) width=availableWidth; // available width
		if(width<this.diffWidth) width=this.diffWidth; // needed width	
    autosizer.sBox.width=width; 
  
	},
	
	focusEnd: function() { 
	  const a=autosizer;
	  // This method only works when the searchabr isn't yet at its max-width
	  selStart=a.txt._textbox.selectionEnd;
		temp=a.txt.value; 
		a.txt.value+=' '; // Just add a space/letter in the end to force the searchbar to realign the text after resizing (cursor is moved here)
		a.txt.value=temp;		
		// Focuses the end even if the searchbar is at its max-width
		if(selStart==a.txt._textbox.textLength) {
			var oEvent = document.createEvent('KeyEvents');  
			oEvent.initKeyEvent("keypress",true,true,null,false,false,false,false,oEvent.DOM_VK_END ,0);
		  a.input.dispatchEvent(oEvent);
		} else a.txt._textbox.setSelectionRange(selStart,selStart);
	}, 
	
	getTooltipWidth: function(canSkip) {
		this.diffWidth=(1+this.sBox.boxObject.width)-this.input.offsetWidth;
		if(this.minwidth>0 && canSkip) {
		 this.tooltipwidth=0;
		 return;
		}
		var temp=this.label.value;   
		this.label.value=this.txt.currentEngine.name;
		this.tooltipwidth=this.label.boxObject.width+this.diffWidth; 
		this.label.value=temp; 
	},     	

	genWidthCheck: function(evt) {
		this.initVar();     
		if(this.label.value!=this.txt.value) this.genWidth(evt);
	},  
	
	afterSubmit: function() {
    if(this.cleanOnSubmit) {
	    this.txt.value='';
	    this.txt.empty=true;
      var inputEvent = document.createEvent('Events');
      if (inputEvent) {
        inputEvent.initEvent('oninput', true, true);
        this.txt.dispatchEvent(inputEvent);
      } 
    }
    if(this.revertOnSubmit) this.txt.currentEngine=this.txt._engines[0];   
	  window.setTimeout("autosizer.genWidthCheck();");
	},

	d: function(t) {
   Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService).logStringMessage('autosizer: '+t);
	},
  
  byId: function(i) {
    return window.document.getElementById(i);
  }
}

window.addEventListener("load",function() { autosizer.init(); }, false);